/* bfbtester -- Brute Force Binary Tester
 *
 * Copyright 2000	Mike Heffner <spock@techfour.net>
 */

#ifndef	__UTILS_H__
#define __UTILS_H__



typedef enum _msg_type	MsgType;
enum _msg_type {
	MSG_TYPE_ERROR_ABORT,
	MSG_TYPE_ERROR_WARN,
	MSG_TYPE_ERRNO_ABORT,
	MSG_TYPE_ERRNO_WARN,
	MSG_TYPE_MESSAGE,		/* no function/line output
							 * if in GUI, sent to log window
							 */

	MSG_TYPE_DEBUG_L1,
	MSG_TYPE_DEBUG_L2
};


#define bfbt_message(type, fmt, args...) \
__bfbt_message(type, __FUNCTION__, __LINE__, fmt, ##args)

#ifdef __GNUC__

void
__bfbt_message(MsgType type, char * function, int line,
			   char *fmt, ...) __attribute__ ((format (printf, 4, 5)));

#else

void
__bfbt_message(MsgType type, char * function, int line,
			   char *fmt, ...);

#endif /* __GNUC__ */

/* Memory allocators */
#define xmalloc(a)	_xmalloc(a, __FUNCTION__, __LINE__)
static __inline__ void *
_xmalloc(size_t size, char *function, int line)
{
	void * temp;
	temp = malloc(size);
	if (!temp)
		bfbt_message(MSG_TYPE_ERRNO_ABORT, "Malloc failed at [%s:%d]",
					 function, line);
	return temp;
}

#define xcalloc(a, b)	_xcalloc(a, b, __FUNCTION__, __LINE__)
static __inline__ void *
_xcalloc(size_t number, size_t size, char *function, int line)
{
	void * temp;
	temp = calloc(number, size);
	if (!temp)
		bfbt_message(MSG_TYPE_ERRNO_ABORT, "Calloc failed at [%s:%d]",
					 function, line);
	return temp;
}

char *
findExec(char *name);

char *
args_to_str(char **args);

char *
env_to_str(char **env);

char **
env_create(char **env);

int
exec_ispermok(char *filename);

#endif /* __UTILS_H__ */
